diff --git a/contrib/auth_delay/auth_delay.conf.sample b/contrib/auth_delay/auth_delay.conf.sample
new file mode 100644
index 0000000..931a7e1
--- /dev/null
+++ b/contrib/auth_delay/auth_delay.conf.sample
@@ -0,0 +1,6 @@
+# -----------------------------
+# auth_delay configuration file
+# -----------------------------
+
+# Delay before reporting authentication failure
+#auth_delay.milliseconds = 0
diff --git a/contrib/auto_explain/auto_explain.conf.sample b/contrib/auto_explain/auto_explain.conf.sample
new file mode 100644
index 0000000..d653690
--- /dev/null
+++ b/contrib/auto_explain/auto_explain.conf.sample
@@ -0,0 +1,31 @@
+# -------------------------------
+# auto_explain configuration file
+# -------------------------------
+
+# Set the minimum execution time above which plans will be logged
+#auto_explain.log_min_duration = -1		# in milliseconds, -1 disables
+
+# Use EXPLAIN ANALYZE for plan logging
+#auto_explain.log_analyze = off
+
+# Use EXPLAIN VERBOSE for plan logging
+#auto_explain.log_verbose = off
+
+# Log buffers usage
+#auto_explain.log_buffers = off
+
+# Include statistics in plans
+#auto_explain.log_triggers = off		# requires log_analyze to also be on
+
+# EXPLAIN format to be used for plan logging
+#auto_explain.log_format = text			# text, xml, json, or yaml
+
+# Log nested statements
+#auto_explain.log_nested_statements = off
+
+# Collect timing data, not just row counts
+#auto_explain.log_timing = on
+
+# Fraction of queries to process
+#auto_explain.sample_rate = 1.0			# range 0.0 - 1.0
+
diff --git a/contrib/pg_stat_statements/pg_stat_statements.conf.sample b/contrib/pg_stat_statements/pg_stat_statements.conf.sample
new file mode 100644
index 0000000..4e8dc66
--- /dev/null
+++ b/contrib/pg_stat_statements/pg_stat_statements.conf.sample
@@ -0,0 +1,15 @@
+# -------------------------------------
+# pg_stat_statements configuration file
+# -------------------------------------
+
+# Set the maximum number of statements to track
+#pg_stat_statements.max = 5000			# minimum 100
+
+# Select which statements are tracked
+#pg_stat_statements.track = top			# none, top, or all
+
+# Select whether utility commands are tracked
+#pg_stat_statements.track_utility = on
+
+# Save statistics across server shutdowns
+#pg_stat_statements.save = on
diff --git a/contrib/pg_trgm/pg_trgm.conf.sample b/contrib/pg_trgm/pg_trgm.conf.sample
new file mode 100644
index 0000000..3118bbe
--- /dev/null
+++ b/contrib/pg_trgm/pg_trgm.conf.sample
@@ -0,0 +1,9 @@
+# --------------------------
+# pg_trgm configuration file
+# --------------------------
+
+# Set the threshold used by the %% operator.
+#pg_trgm.similarity_threshold = 0.3			# range 0.0 - 1.0
+
+# Set the threshold used by the <%% operator.
+#pg_trgm.word_similarity_threshold = 0.6	# range 0.0 - 1.0
diff --git a/contrib/sepgsql/sepgsql.conf.sample b/contrib/sepgsql/sepgsql.conf.sample
new file mode 100644
index 0000000..f7f0ec0
--- /dev/null
+++ b/contrib/sepgsql/sepgsql.conf.sample
@@ -0,0 +1,9 @@
+# --------------------------
+# sepgsql configuration file
+# --------------------------
+
+# Turn on/off permissive mode in SE-PostgreSQL
+#sepgsql.permissive = off
+
+# Turn on/off debug audit messages
+#sepgsql.debug_audit = off
diff --git a/src/pl/plperl/plperl.conf.sample b/src/pl/plperl/plperl.conf.sample
new file mode 100644
index 0000000..7bba7b9
--- /dev/null
+++ b/src/pl/plperl/plperl.conf.sample
@@ -0,0 +1,15 @@
+# -------------------------
+# plperl configuration file
+# -------------------------
+
+# Compile trusted and untrusted Perl code in strict mode
+#plperl.use_strict = off
+
+# Perl code to execute when a Perl interpreter is initialized
+#plperl.on_init = ''
+
+# Perl code to execute once when plperl is first used
+#plperl.on_plperl_init = ''
+
+# Perl code to execute once when plperlu is first used
+#plperl.on_plperl_init = ''
diff --git a/src/pl/plpgsql/src/plpgsql.conf.sample b/src/pl/plpgsql/src/plpgsql.conf.sample
new file mode 100644
index 0000000..39eb6fb
--- /dev/null
+++ b/src/pl/plpgsql/src/plpgsql.conf.sample
@@ -0,0 +1,19 @@
+# --------------------------
+# plpgsql configuration file
+# --------------------------
+
+# Set handling of conflicts between PL/pgSQL variable names and table column
+# names
+#plpgsql.variable_conflict = error	# error, use_variable, or use_column
+
+# Print information about parameters in the DETAIL part of the error messages
+# generated on INTO ... STRICT failures
+#plpgsql.print_strict_params = off
+
+# Perform checks given in ASSERT statements
+#plpgsql.check_asserts = on
+
+# List of programming constructs that should produce a warning or an error
+# Currenty only "shadowed_variables" is supported, as well as "all" or "none"
+#plpgsql.extra_warnings = 'none'
+#plpgsql.extra_errors = 'none'